## gitlab 17.6.5

=== workhorse/Makefile ===
PREFIX=/usr/local

FIPS_MODE ?= 0
PKG := gitlab.com/gitlab-org/gitlab/workhorse
BUILD_DIR ?= $(CURDIR)
TARGET_DIR ?= $(BUILD_DIR)/_build
VERSION_STRING := $(shell git describe)
ifeq ($(strip $(VERSION_STRING)),)
VERSION_STRING := v$(shell cat VERSION)
endif
DATE_FMT = +%Y%m%d.%H%M%S
ifdef SOURCE_DATE_EPOCH
	BUILD_TIME := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u "$(DATE_FMT)")
else
	BUILD_TIME := $(shell date -u "$(DATE_FMT)")
endif
GO_BUILD_GENERIC_LDFLAGS := -X main.Version=$(VERSION_STRING) -X main.BuildTime=$(BUILD_TIME)
GITALY  := tmp/tests/gitaly/_build/bin/gitaly
GITALY_PID_FILE := gitaly.pid
EXE_ALL := gitlab-resize-image gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
INSTALL := install
BUILD_TAGS := tracer_static tracer_static_jaeger continuous_profiler_stackdriver

OS := $(shell uname | tr A-Z a-z)
ARCH ?= $(shell uname -m | sed -e 's/x86_64/amd64/' | sed -e 's/aarch64/arm64/')

GOLANGCI_LINT_VERSION := 1.60.3
GOLANGCI_LINT_ARCH ?= ${ARCH}
GOLANGCI_LINT_FILE := _support/bin/golangci-lint-${GOLANGCI_LINT_VERSION}

ifeq (${FIPS_MODE}, 1)
    # boringcrypto tag is added automatically by golang-fips compiler
    BUILD_TAGS += fips
    # If the golang-fips compiler is built with CGO_ENABLED=0, this needs to be
    # explicitly switched on.
    export CGO_ENABLED=1
    # Go 1.19+ now requires GOEXPERIMENT=boringcrypto for FIPS compilation.
    # See https://github.com/golang/go/issues/51940 for more details.
    ifeq ($(shell GOEXPERIMENT=boringcrypto go version > /dev/null 2>&1; echo $$?), 0)
      export GOEXPERIMENT=boringcrypto
    endif
endif

export GOBIN := $(TARGET_DIR)/bin
export PATH := $(GOBIN):$(PATH)
export GOPROXY ?= https://proxy.golang.org
export GO111MODULE=on

define message
	@echo "### $(1)"
endef

.NOTPARALLEL:

.PHONY:	all
all:	clean-build $(EXE_ALL)

.PHONY: gitlab-resize-image gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
gitlab-resize-image gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse:
	$(call message,Building $@)
	go build -ldflags "$(GO_BUILD_GENERIC_LDFLAGS) -B gobuildid" -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

.PHONY:	install
install: $(EXE_ALL)
	$(call message,$@)
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	cd $(BUILD_DIR) && $(INSTALL) $(EXE_ALL) $(DESTDIR)$(PREFIX)/bin/

.PHONY:	test
test: prepare-tests
	$(call message,$@)
	@if [ -z "$${GITALY_ADDRESS+x}" ] ; then \
		echo "To run gitaly integration tests set GITALY_ADDRESS=tcp://127.0.0.1:8075" ; \
	else \
		$(MAKE) run-gitaly ; \
	fi
	go test ${TEST_OPTIONS} -tags "$(BUILD_TAGS)" ./...
	@status="$$?" ;\
	if [ -f "$(GITALY_PID_FILE)" ] ; then \
		echo "Clean up Gitaly server for workhorse integration test" ;\
		kill -9 $$(cat $(GITALY_PID_FILE)) ;\
		rm $(GITALY_PID_FILE) ;\
	else \
		echo "Gitaly integration test not running" ;\
	fi ;\
	exit "$$status"
	@echo SUCCESS

.PHONY: test-race
test-race: TEST_OPTIONS = -race
test-race: test

.PHONY: test-coverage
test-coverage: TEST_OPTIONS = -cover -coverprofile=cover.out
test-coverage: test
	$(call message, "Calculating the coverage")
	[ -f cover.out ] && go tool cover -html cover.out -o coverage.html
	[ -f cover.out ] && go tool cover -func cover.out

.PHONY:	clean
clean: clean-workhorse clean-build
	$(call message,$@)
	rm -rf testdata/data testdata/scratch cover.out coverage.html

.PHONY:	clean-workhorse
clean-workhorse:
	$(call message,$@)
	rm -f $(EXE_ALL)

.PHONY:	clean-build
clean-build:
	$(call message,$@)
	rm -rf $(TARGET_DIR)

.PHONY:	prepare-tests
prepare-tests: testdata/scratch $(EXE_ALL)

.PHONY: run-gitaly
run-gitaly: $(GITALY_PID_FILE)

$(GITALY_PID_FILE): gitaly.toml
	$(call message, "Starting gitaly")
	cd ..; GITALY_TESTING_NO_GIT_HOOKS=1 GITALY_PID_FILE=workhorse/$(GITALY_PID_FILE) scripts/gitaly-test-spawn workhorse/gitaly.toml

GITALY_CONFIGURATION_SOURCE_BASE = ../tmp/tests/gitaly/config.toml
ifeq ($(GITALY_TRANSACTIONS_ENABLED),true)
	GITALY_CONFIGURATION_SOURCE = ${GITALY_CONFIGURATION_SOURCE_BASE}.transactions
else
	GITALY_CONFIGURATION_SOURCE = ${GITALY_CONFIGURATION_SOURCE_BASE}
endif

# Mark the target phony so the configuration is always refreshed in case the `GITALY_TRANSACTIONS_ENABLED`
# environment variable has been changed.
.PHONY: gitaly.toml
gitaly.toml: ${GITALY_CONFIGURATION_SOURCE}
	sed -e 's/^socket_path.*$$/listen_addr = "0.0.0.0:8075"/;s/^\[auth\]$$//;s/^token.*$$//;s/^internal_socket_dir.*$$//' \
		$< > $@

../tmp/tests/gitaly/config.toml:
	$(call message, "Building a complete test environment")
	cd .. ; ./scripts/setup-test-env

testdata/scratch:
	mkdir -p testdata/scratch

.PHONY: verify
verify: lint vet detect-context detect-external-tests check-formatting staticcheck deps-check

.PHONY: lint
lint:
	$(call message,Verify: $@)
	@_support/lint.sh ./...

.PHONY: golangci
golangci: ${GOLANGCI_LINT_FILE}
	@${GOLANGCI_LINT_FILE} cache clean
	@${GOLANGCI_LINT_FILE} run --issues-exit-code 0 --print-issued-lines=false ${GOLANGCI_LINT_ARGS}

${GOLANGCI_LINT_FILE}:
	@mkdir -p $(shell dirname ${GOLANGCI_LINT_FILE})
	@curl -L https://github.com/golangci/golangci-lint/releases/download/v${GOLANGCI_LINT_VERSION}/golangci-lint-${GOLANGCI_LINT_VERSION}-${OS}-${GOLANGCI_LINT_ARCH}.tar.gz | tar --strip-components 1 -zOxf - golangci-lint-${GOLANGCI_LINT_VERSION}-${OS}-${GOLANGCI_LINT_ARCH}/golangci-lint > ${GOLANGCI_LINT_FILE} && chmod +x ${GOLANGCI_LINT_FILE}

.PHONY: vet
vet:
	$(call message,Verify: $@)
	@go vet ./...

.PHONY: detect-context
detect-context:
	$(call message,Verify: $@)
	_support/detect-context.sh

.PHONY: detect-external-tests
detect-external-tests:
	$(call message,Verify: $@)
	_support/detect-external-tests.sh

.PHONY: check-formatting
check-formatting: install-goimports
	$(call message,Verify: $@)
	@_support/fmt.sh check

# Megacheck will tailor some responses given a minimum Go version, so pass that through the CLI
# Additionally, megacheck will not return failure exit codes unless explicitly told to via the
# `-simple.exit-non-zero` `-unused.exit-non-zero` and `-staticcheck.exit-non-zero` flags
.PHONY: staticcheck
staticcheck:
	$(call message,Verify: $@)
	go install honnef.co/go/tools/cmd/staticcheck@latest
	@ $(GOBIN)/staticcheck ./...

# In addition to fixing imports, goimports also formats your code in the same style as gofmt
# so it can be used as a replacement.
.PHONY: fmt
fmt: install-goimports
	$(call message,$@)
	@_support/fmt.sh

.PHONY:	goimports
install-goimports:
	$(call message,$@)
	go install golang.org/x/tools/cmd/goimports

.PHONY: deps-check
deps-check:
	go mod tidy
	@if git diff --quiet --exit-code -- go.mod go.sum; then \
		echo "go.mod and go.sum are ok"; \
	else \
		echo ""; \
		echo "go.mod and go.sum are modified, please commit them";\
		exit 1; \
	fi;

=== github.com/redis/go-redis/v9/Makefile ===
GO_MOD_DIRS := $(shell find . -type f -name 'go.mod' -exec dirname {} \; | sort)

test: testdeps
	set -e; for dir in $(GO_MOD_DIRS); do \
	  echo "go test in $${dir}"; \
	  (cd "$${dir}" && \
	    go mod tidy -compat=1.18 && \
	    go test && \
	    go test ./... -short -race && \
	    go test ./... -run=NONE -bench=. -benchmem && \
	    env GOOS=linux GOARCH=386 go test && \
	    go vet); \
	done
	cd internal/customvet && go build .
	go vet -vettool ./internal/customvet/customvet

testdeps: testdata/redis/src/redis-server

bench: testdeps
	go test ./... -test.run=NONE -test.bench=. -test.benchmem

.PHONY: all test testdeps bench

testdata/redis:
	mkdir -p $@
	wget -qO- https://download.redis.io/releases/redis-7.2-rc3.tar.gz | tar xvz --strip-components=1 -C $@

testdata/redis/src/redis-server: testdata/redis
	cd $< && make all

fmt:
	gofmt -w -s ./
	goimports -w  -local github.com/redis/go-redis ./

go_mod_tidy:
	set -e; for dir in $(GO_MOD_DIRS); do \
	  echo "go mod tidy in $${dir}"; \
	  (cd "$${dir}" && \
	    go get -u ./... && \
	    go mod tidy -compat=1.18); \
	done

=== gitlab.com/gitlab-org/gitaly/v15/Makefile ===
# Makefile for Gitaly

# You can override options by creating a "config.mak" file in Gitaly's root
# directory.
-include config.mak

# Unexport environment variables which have an effect on Git itself.
# We need to keep GIT_PREFIX because it's used to determine where our
# self-built Git should be installed into. It's probably not going to
# matter much though.
unexport $(filter-out GIT_PREFIX,$(shell git rev-parse --local-env-vars))

# Call `make V=1` in order to print commands verbosely.
ifeq ($(V),1)
    Q =
else
    Q = @
endif

SHELL = /usr/bin/env bash -eo pipefail

# Host information
OS   := $(shell uname)
ARCH := $(shell uname -m)

# Directories
SOURCE_DIR       := $(abspath $(dir $(lastword ${MAKEFILE_LIST})))
BUILD_DIR        := ${SOURCE_DIR}/_build
PROTO_DEST_DIR   := ${SOURCE_DIR}/proto/go
DEPENDENCY_DIR   := ${BUILD_DIR}/deps
TOOLS_DIR        := ${BUILD_DIR}/tools
GITALY_RUBY_DIR  := ${SOURCE_DIR}/ruby
# This file is used as a dependency for running `bundle install`: when its
# mtime is older than that of either `Gemfile` or `Gemfile.lock` we will
# execute the command. There is not typically any need to change the location,
# but we need this for our unprivileged CI so that it can be moved into the
# `_build` directory. Just moving the file completely doesn't work, as both CNG
# and Omnibus depend on it to inhibit re-bundling Ruby Gems.
RUBY_BUNDLE_FILE ?= ${SOURCE_DIR}/.ruby-bundle

# These variables may be overridden at runtime by top-level make
## The prefix where Gitaly binaries will be installed to. Binaries will end up
## in ${PREFIX}/bin by default.
PREFIX           ?= /usr/local
prefix           ?= ${PREFIX}
exec_prefix      ?= ${prefix}
bindir           ?= ${exec_prefix}/bin
INSTALL_DEST_DIR := ${DESTDIR}${bindir}
## The prefix where Git will be installed to.
GIT_PREFIX       ?= ${PREFIX}

# Tools
GIT                         := $(shell command -v git)
GOIMPORTS                   := ${TOOLS_DIR}/goimports
GOFUMPT                     := ${TOOLS_DIR}/gofumpt
GOLANGCI_LINT               := ${TOOLS_DIR}/golangci-lint
PROTOLINT                   := ${TOOLS_DIR}/protolint
GO_LICENSES                 := ${TOOLS_DIR}/go-licenses
PROTOC                      := ${TOOLS_DIR}/protoc
PROTOC_GEN_GO               := ${TOOLS_DIR}/protoc-gen-go
PROTOC_GEN_GO_GRPC          := ${TOOLS_DIR}/protoc-gen-go-grpc
PROTOC_GEN_GITALY_LINT      := ${TOOLS_DIR}/protoc-gen-gitaly-lint
PROTOC_GEN_GITALY_PROTOLIST := ${TOOLS_DIR}/protoc-gen-gitaly-protolist
GOTESTSUM                   := ${TOOLS_DIR}/gotestsum
GOCOVER_COBERTURA           := ${TOOLS_DIR}/gocover-cobertura
DELVE                       := ${TOOLS_DIR}/dlv

# Tool options
GOLANGCI_LINT_OPTIONS ?=
GOLANGCI_LINT_CONFIG  ?= ${SOURCE_DIR}/.golangci.yml

# Build information
GITALY_PACKAGE    := gitlab.com/gitlab-org/gitaly/v15
GITALY_VERSION    := $(shell ${GIT} describe --match v* 2>/dev/null | sed 's/^v//' || cat ${SOURCE_DIR}/VERSION 2>/dev/null || echo unknown)
GO_LDFLAGS        := -X ${GITALY_PACKAGE}/internal/version.version=${GITALY_VERSION}
SERVER_BUILD_TAGS := tracer_static,tracer_static_jaeger,tracer_static_stackdriver,continuous_profiler_stackdriver
GIT2GO_BUILD_TAGS := static,system_libgit2

# Temporary GNU build ID used as a placeholder value so that we can replace it
# with our own one after binaries have been built. This is the ASCII encoding
# of the string "TEMP_GITALY_BUILD_ID".
TEMPORARY_BUILD_ID := 54454D505F474954414C595F4255494C445F4944

## FIPS_MODE controls whether to build Gitaly and dependencies in FIPS mode.
## Set this to a non-empty value to enable it.
FIPS_MODE ?=

ifdef FIPS_MODE
    SERVER_BUILD_TAGS := ${SERVER_BUILD_TAGS},fips
    GIT2GO_BUILD_TAGS := ${GIT2GO_BUILD_TAGS},fips

    # Build Git with the OpenSSL backend for SHA256 in case FIPS-mode is
    # requested. Note that we explicitly don't do the same for SHA1: we
    # instead use SHA1DC to protect users against the SHAttered attack.
    GIT_FIPS_BUILD_OPTIONS := OPENSSL_SHA256=YesPlease

    export GITALY_TESTING_ENABLE_FIPS := YesPlease
endif

ifdef GITALY_TESTING_ENABLE_SHA256
    SERVER_BUILD_TAGS := ${SERVER_BUILD_TAGS},gitaly_test_sha256
    GIT2GO_BUILD_TAGS := ${GIT2GO_BUILD_TAGS},gitaly_test_sha256
endif

# protoc target
PROTOC_VERSION      ?= v21.7
PROTOC_REPO_URL     ?= https://github.com/protocolbuffers/protobuf
PROTOC_SOURCE_DIR   ?= ${DEPENDENCY_DIR}/protobuf/source
PROTOC_BUILD_DIR    ?= ${DEPENDENCY_DIR}/protobuf/build
PROTOC_INSTALL_DIR  ?= ${DEPENDENCY_DIR}/protobuf/install

ifeq ($(origin PROTOC_BUILD_OPTIONS),undefined)
    ## Build options for protoc.
    PROTOC_BUILD_OPTIONS ?=
    PROTOC_BUILD_OPTIONS += -DBUILD_SHARED_LIBS=NO
    PROTOC_BUILD_OPTIONS += -DCMAKE_INSTALL_PREFIX=${PROTOC_INSTALL_DIR}
    PROTOC_BUILD_OPTIONS += -Dprotobuf_BUILD_TESTS=OFF
endif

# Git target
GIT_REPO_URL       ?= https://gitlab.com/gitlab-org/git.git
GIT_QUIET          :=
ifeq (${Q},@)
    GIT_QUIET = --quiet
endif

GIT_EXECUTABLES += git
GIT_EXECUTABLES += git-remote-http
GIT_EXECUTABLES += git-http-backend

## The version of Git to build and test Gitaly with when not used
## WITH_BUNDLED_GIT=YesPlease. Can be set to an arbitrary Git revision with
## tags, branches, and commit ids.
GIT_VERSION ?=
## The Git version used for bundled Git v2.38.
GIT_VERSION_2_38 ?= v2.38.4.gl1
## The Git version used for bundled Git v2.39.
GIT_VERSION_2_39 ?= v2.39.2

## Skip overriding the Git version and instead use the Git version as specified
## in the Git sources. This is required when building Git from a version that
## cannot be parsed by Gitaly.
SKIP_OVERRIDING_GIT_VERSION ?=

# The default version is used in case the caller does not set the variable or
# if it is either set to the empty string or "default".
ifeq (${GIT_VERSION:default=},)
    override GIT_VERSION := ${GIT_VERSION_2_38}
else
    # Support both vX.Y.Z and X.Y.Z version patterns, since callers across GitLab
    # use both.
    override GIT_VERSION := $(shell echo ${GIT_VERSION} | awk '/^[0-9]\.[0-9]+\.[0-9]+$$/ { printf "v" } { print $$1 }')
endif

ifeq ($(origin GIT_BUILD_OPTIONS),undefined)
    ## Build options for Git.
    GIT_BUILD_OPTIONS ?=
    # activate developer checks
    GIT_BUILD_OPTIONS += DEVELOPER=1
    # but don't cause warnings to fail the build
    GIT_BUILD_OPTIONS += DEVOPTS=no-error
    GIT_BUILD_OPTIONS += USE_LIBPCRE=YesPlease
    GIT_BUILD_OPTIONS += NO_PERL=YesPlease
    GIT_BUILD_OPTIONS += NO_EXPAT=YesPlease
    GIT_BUILD_OPTIONS += NO_TCLTK=YesPlease
    GIT_BUILD_OPTIONS += NO_GETTEXT=YesPlease
    GIT_BUILD_OPTIONS += NO_PYTHON=YesPlease
    PCRE_PC=libpcre2-8
    ifeq ($(shell pkg-config --exists ${PCRE_PC} && echo exists),exists)
	    GIT_BUILD_OPTIONS += LIBPCREDIR=$(shell pkg-config ${PCRE_PC} --variable prefix)
    endif
endif

ifdef GIT_APPEND_BUILD_OPTIONS
	GIT_BUILD_OPTIONS += ${GIT_APPEND_BUILD_OPTIONS}
endif

ifdef GIT_FIPS_BUILD_OPTIONS
	GIT_BUILD_OPTIONS += ${GIT_FIPS_BUILD_OPTIONS}
endif

# libgit2 target
# Git2Go and libgit2 may need to be updated in sync. Please refer to
# https://github.com/libgit2/git2go/#which-go-version-to-use for a
# compatibility matrix.
GIT2GO_VERSION      ?= v34
LIBGIT2_VERSION     ?= v1.5.1
LIBGIT2_REPO_URL    ?= https://gitlab.com/libgit2/libgit2.git
LIBGIT2_SOURCE_DIR  ?= ${DEPENDENCY_DIR}/libgit2/source
LIBGIT2_BUILD_DIR   ?= ${DEPENDENCY_DIR}/libgit2/build
LIBGIT2_INSTALL_DIR ?= ${DEPENDENCY_DIR}/libgit2/install

ifeq ($(origin LIBGIT2_BUILD_OPTIONS),undefined)
    ## Build options for libgit2.
    LIBGIT2_BUILD_OPTIONS ?=
    LIBGIT2_BUILD_OPTIONS += -DBUILD_CLI=OFF
    LIBGIT2_BUILD_OPTIONS += -DBUILD_TESTS=OFF
    LIBGIT2_BUILD_OPTIONS += -DBUILD_SHARED_LIBS=OFF
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_C_FLAGS=-fPIC
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_BUILD_TYPE=Release
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_INSTALL_PREFIX=${LIBGIT2_INSTALL_DIR}
    LIBGIT2_BUILD_OPTIONS += -DCMAKE_INSTALL_LIBDIR=lib
    LIBGIT2_BUILD_OPTIONS += -DUSE_SSH=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_HTTPS=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_ICONV=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_NTLMCLIENT=OFF
    LIBGIT2_BUILD_OPTIONS += -DUSE_BUNDLED_ZLIB=ON
    LIBGIT2_BUILD_OPTIONS += -DUSE_HTTP_PARSER=builtin
    LIBGIT2_BUILD_OPTIONS += -DUSE_THREADS=ON
    LIBGIT2_BUILD_OPTIONS += -DREGEX_BACKEND=builtin
endif

ifdef LIBGIT2_APPEND_BUILD_OPTIONS
	LIBGIT2_BUILD_OPTIONS += ${LIBGIT2_APPEND_BUILD_OPTIONS}
endif

# These variables control test options and artifacts
## List of Go packages which shall be tested.
## Go packages to test when using the test-go target.
TEST_PACKAGES     ?= ${SOURCE_DIR}/...
## Test options passed to `go test`.
TEST_OPTIONS      ?= -count=1
## Specify the output format used to print tests ["standard-verbose", "standard-quiet", "short"]
TEST_FORMAT       ?= short
TEST_REPORT       ?= ${BUILD_DIR}/reports/go-tests-report.xml
# Full output of `go test -json`
TEST_FULL_OUTPUT  ?= /dev/null
## Specify the output directory for test coverage reports.
TEST_COVERAGE_DIR ?= ${BUILD_DIR}/cover
## Directory where all runtime test data is being created.
TEST_TMP_DIR      ?=
## Directory where Gitaly should write logs to during test execution.
TEST_LOG_DIR	  ?=
TEST_REPO_DIR     := ${BUILD_DIR}/testrepos
TEST_REPO         := ${TEST_REPO_DIR}/gitlab-test.git
BENCHMARK_REPO    := ${TEST_REPO_DIR}/benchmark.git
## Options to pass to the script which builds the Gitaly gem
BUILD_GEM_OPTIONS ?=

# All executables provided by Gitaly.
GITALY_EXECUTABLES           = $(addprefix ${BUILD_DIR}/bin/,$(notdir $(shell find ${SOURCE_DIR}/cmd -mindepth 1 -maxdepth 1 -type d -print)))
# All executables packed inside the Gitaly binary.
GITALY_PACKED_EXECUTABLES    = $(filter %gitaly-hooks %gitaly-git2go %gitaly-ssh %gitaly-lfs-smudge, ${GITALY_EXECUTABLES})
# All executables that should be installed.
GITALY_INSTALLED_EXECUTABLES = $(filter-out ${GITALY_PACKED_EXECUTABLES}, ${GITALY_EXECUTABLES})
# Find all Go source files.
find_go_sources              = $(shell find ${SOURCE_DIR} -type d \( -path "${SOURCE_DIR}/_*" -o -path "${SOURCE_DIR}/ruby" -o -path "${SOURCE_DIR}/proto" \) -prune -o -type f -name '*.go' -print | sort -u)

# run_go_tests will execute Go tests with all required parameters. Its
# behaviour can be modified via the following variables:
#
# TEST_OPTIONS: any additional options
# TEST_PACKAGES: packages which shall be tested
# TEST_LOG_DIR: specify the output log dir. By default, all logs will be discarded
run_go_tests = PATH='${SOURCE_DIR}/internal/testhelper/testdata/home/bin:${PATH}' \
    TEST_TMP_DIR='${TEST_TMP_DIR}' \
    TEST_LOG_DIR='${TEST_LOG_DIR}' \
    ${GOTESTSUM} --format ${TEST_FORMAT} --junitfile ${TEST_REPORT} --jsonfile ${TEST_FULL_OUTPUT} -- -ldflags '${GO_LDFLAGS}' -tags '${SERVER_BUILD_TAGS},${GIT2GO_BUILD_TAGS},gitaly_test_signing' ${TEST_OPTIONS} ${TEST_PACKAGES}

## Test options passed to `dlv test`.
DEBUG_OPTIONS      ?= $(patsubst -%,-test.%,${TEST_OPTIONS})

# debug_go_tests will execute Go tests from a single package in the delve debugger.
# Its behaviour can be modified via the following variable:
#
# DEBUG_OPTIONS: any additional options, will default to TEST_OPTIONS if not set.
debug_go_tests = PATH='${SOURCE_DIR}/internal/testhelper/testdata/home/bin:${PATH}' \
    TEST_TMP_DIR='${TEST_TMP_DIR}' \
    ${DELVE} test --build-flags="-ldflags '${GO_LDFLAGS}' -tags '${SERVER_BUILD_TAGS},${GIT2GO_BUILD_TAGS}'" ${TEST_PACKAGES} -- ${DEBUG_OPTIONS}

unexport GOROOT
## GOCACHE_MAX_SIZE_KB is the maximum size of Go's build cache in kilobytes before it is cleaned up.
GOCACHE_MAX_SIZE_KB              ?= 5000000
export GOCACHE                   ?= ${BUILD_DIR}/cache
export GOPROXY                   ?= https://proxy.golang.org
export PATH                      := ${BUILD_DIR}/bin:${PATH}
export PKG_CONFIG_PATH           := ${LIBGIT2_INSTALL_DIR}/lib/pkgconfig
# Allow the linker flag -D_THREAD_SAFE as libgit2 is compiled with it on FreeBSD
export CGO_LDFLAGS_ALLOW          = -D_THREAD_SAFE

=== debian/changelog ===
gitlab (17.6.5-19) unstable; urgency=medium

  * Don't manually install openssl gem (ruby 3.1 is no longer supported)
  * Use json5 to clean up package.json (fixes yarn install failure)

 -- Pirate Praveen <praveen@debian.org>  Thu, 10 Jul 2025 14:12:36 +0200

gitlab (17.6.5-18) unstable; urgency=medium

  * Run db:seed_fu for new installations (Work around for #1107585)

 -- Pirate Praveen <praveen@debian.org>  Wed, 09 Jul 2025 15:53:07 +0200

gitlab (17.6.5-17) unstable; urgency=medium

  * Remove packageManager field added to package.json by yarnpkg

 -- Pirate Praveen <praveen@debian.org>  Sat, 14 Jun 2025 01:33:05 +0530

gitlab (17.6.5-16) unstable; urgency=medium

  * Add ruby-prometheus-client-mmap as dependency

 -- Pirate Praveen <praveen@debian.org>  Fri, 13 Jun 2025 19:14:42 +0530

gitlab (17.6.5-15) unstable; urgency=medium

  * Drop dependency on ruby-webauthn

 -- Pirate Praveen <praveen@debian.org>  Sat, 03 May 2025 00:14:18 +0530

gitlab (17.6.5-14) unstable; urgency=medium

  * Drop ruby-sidekiq-cron and ruby-fugit dependencies

 -- Pirate Praveen <praveen@debian.org>  Wed, 30 Apr 2025 15:58:15 +0530

gitlab (17.6.5-13) unstable; urgency=medium

  * Drop dependency on ruby-sprockets-rails and ruby-terser

 -- Pirate Praveen <praveen@debian.org>  Tue, 22 Apr 2025 12:39:05 +0530

gitlab (17.6.5-12) unstable; urgency=medium

  * Drop dependency on ruby-omniauth-auth0 and ruby-jira

 -- Pirate Praveen <praveen@debian.org>  Tue, 22 Apr 2025 01:43:28 +0530

gitlab (17.6.5-11) unstable; urgency=medium

  * Drop dependency on ruby-redis-actionpack and ruby-redis-store

 -- Pirate Praveen <praveen@debian.org>  Sat, 19 Apr 2025 19:09:03 +0530

gitlab (17.6.5-10) unstable; urgency=medium

  * Drop ruby-octokit and ruby-licensee dependencies

 -- Pirate Praveen <praveen@debian.org>  Sat, 19 Apr 2025 15:15:11 +0530

gitlab (17.6.5-9) unstable; urgency=medium

  * Drop ruby-grape-entity and ruby-kas-grpc dependencies
  * Drop ruby-grape-* from dependencies

 -- Pirate Praveen <praveen@debian.org>  Thu, 17 Apr 2025 16:10:37 +0530

gitlab (17.6.5-8) unstable; urgency=medium

  * Make sure we have ruby 3.3 and older libruby is removed (via conflicts)
  * Drop dependency on ruby-omniauth-ldap, ruby-omniauth-kerberos,
    ruby-responders

 -- Pirate Praveen <praveen@debian.org>  Thu, 17 Apr 2025 14:42:18 +0530

gitlab (17.6.5-7) unstable; urgency=medium

  * Remove gem uninstall command for concurrent-ruby in postinst
  * Drop dependency on ruby-saml and ruby-omniauth-saml

 -- Pirate Praveen <praveen@debian.org>  Thu, 17 Apr 2025 00:36:41 +0530

gitlab (17.6.5-6) unstable; urgency=medium

  * Drop ruby-google-protobuf, ruby-pg-query and ruby-grpc dependencies
  * Remove X?-Ruby-Versions fields from d/control

 -- Pirate Praveen <praveen@debian.org>  Wed, 16 Apr 2025 17:33:27 +0530

gitlab (17.6.5-5) unstable; urgency=medium

  * Update minimum version of golang-github-aws-smithy-go-dev
  * Remove more obsolete feature flags
  * Drop dependency on ruby-omniauth-oauth and ruby-icalendar

 -- Pirate Praveen <praveen@debian.org>  Wed, 16 Apr 2025 01:23:08 +0530

gitlab (17.6.5-4) unstable; urgency=medium

  * Drop ruby-devise and ruby-mail-room dependencies
  * Set ROOT_PATH to /var/lib/gitlab for pdfjs-dist
  * Set NODE_OPTIONS="--max-old-space-size" from 4096 to 7168

 -- Pirate Praveen <praveen@debian.org>  Sat, 12 Apr 2025 01:57:55 +0530

gitlab (17.6.5-3) unstable; urgency=medium

  * Drop ruby-devise-two-factor and ruby-graphlient dependencies

 -- Pirate Praveen <praveen@debian.org>  Fri, 11 Apr 2025 23:10:41 +0530

gitlab (17.6.5-2) unstable; urgency=medium

  * Create shared/artifacts/tmp directory
  * Remove initializer that patched sprockets 3.x (we have 4)
  * Create secrets.yml in a directory writeable by gitlab user

 -- Pirate Praveen <praveen@debian.org>  Wed, 09 Apr 2025 23:24:43 +0530

gitlab (17.6.5-1) unstable; urgency=medium

  * Update minimum version of ruby-bundler to 2.6 for --prefer-local option
  * New upstream version 17.6.5
  * Refresh patches
  * Update upstream files list

 -- Pirate Praveen <praveen@debian.org>  Sun, 06 Apr 2025 23:55:15 +0530

gitlab (17.5.5-6) unstable; urgency=medium

  * Always set yarn version to classic

 -- Pirate Praveen <praveen@debian.org>  Sat, 05 Apr 2025 03:09:40 +0530

gitlab (17.5.5-5) unstable; urgency=medium

  * Handles secrets.yml via ucf (gitlab now needs the example file)
  * Drop all gems except prometheus-client-mmap from gem-install.list
  * Remove sprockets_patch.rb initializer
    (this should be reverted in bookworm-fasttrack branch)

 -- Pirate Praveen <praveen@debian.org>  Sat, 05 Apr 2025 01:45:16 +0530

gitlab (17.5.5-4) unstable; urgency=medium

  * Drop custom gem installs from gitlab.postinst
  * Drop ruby-gitlab-labkit and ruyb-thrift from dependencies
  * Drop ruby-prometheus-client-mmap dependency
  * Lock gitlab-glfm-markdown to 0.0.21 using a patch
  * Lock concurrent-ruby to 1.3.4

 -- Pirate Praveen <praveen@debian.org>  Fri, 04 Apr 2025 13:17:18 +0530

gitlab (17.5.5-3) unstable; urgency=medium

  * Drop ruby-premailer-rails dependency
  * Switch gitaly to gitaly-installer in recommends

 -- Pirate Praveen <praveen@debian.org>  Fri, 04 Apr 2025 01:31:41 +0530

gitlab (17.5.5-2) unstable; urgency=medium

  * Drop ruby-view-component as dependency
  * Switch to --prefer-local from --local for bundle install
    (This makes all rubygems dependencies as optional, any
    dependency not found locally will be fetched from rubygems.org).
  * Add git as an explicit dependency for gitlab-security_report_schemas
  * Remove obsolete feature_flags
  * Update css building commands
  * yarn needs node-gyp for building some node modules

 -- Pirate Praveen <praveen@debian.org>  Wed, 02 Apr 2025 22:29:40 +0530

gitlab (17.5.5-1) unstable; urgency=medium

  [ Utkarsh Gupta ]
  * Drop ruby-omniauth-openid-connect - it'll be dropped from the archive

  [ Pirate Praveen ]


=== debian/control ===
Source: gitlab
Section: net
Priority: optional
Maintainer: Debian Ruby Team <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
Uploaders: Cédric Boutillier <boutil@debian.org>,
 Pirate Praveen <praveen@debian.org>,
 Balasankar C <balasankarc@debian.org>,
 Sruthi Chandran <srud@debian.org>,
 Utkarsh Gupta <utkarsh@debian.org>
Build-Depends: debhelper-compat (= 13),
               gem2deb,
               dh-golang,
# See #1016217 (gccgo and x/net don't work well together right now)
#               golang-any (>= 2:1.17~),
               golang-go (>= 2:1.21~),
               bc,
               golang-github-alecthomas-chroma-v2-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-aws-smithy-go-dev (>= 1.19~),
               golang-github-azure-azure-storage-blob-go-dev (>= 0.10~),
               golang-github-beorn7-perks-dev,
               golang-github-client9-reopen-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-dgryski-go-rendezvous-dev,
               golang-github-disintegration-imaging-dev,
               golang-github-fzambia-sentinel-dev,
               golang-github-garyburd-redigo-dev,
               golang-github-golang-jwt-jwt-dev (>= 4.4.3~),
               golang-github-googleapis-enterprise-certificate-proxy-dev (>= 0.3~),
               golang-github-google-uuid-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-golang-protobuf-1-5-dev,
               golang-github-getsentry-raven-go-dev (>= 0.2~),
               golang-github-gomodule-redigo-dev,
# protobuf-1-5
#               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
               golang-github-jfbus-httprs-dev,
                 golang-github-jtolds-gls-dev (>= 4.20~),
               golang-github-jpillora-backoff-dev,
               golang-github-mitchellh-copystructure-dev,
               golang-github-mitchellh-reflectwalk-dev,
               golang-github-pmezard-go-difflib-dev,
# protobuf-1-5
#               golang-github-prometheus-client-golang-dev,
                  golang-github-cespare-xxhash-dev,
#               golang-github-prometheus-client-model-dev,
#               golang-github-prometheus-common-dev,
               golang-github-ryszard-goskiplist-dev,
               golang-github-sebest-xff-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-stretchr-testify-dev (>= 1.4~),
               golang-gitlab-gitlab-org-gitaly-dev (>= 16.11~),
                 golang-github-beevik-ntp-dev,
# protobuf-1-5
#               golang-gitlab-gitlab-org-labkit-dev (>= 1.14~),
                  golang-github-oklog-ulid-dev,
#               golang-gocloud-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev (>= 1:0.19~),
               golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
# protobuf-1-5
#               golang-google-genproto-dev,
               golang-honnef-go-tools-dev,
               golang-procfs-dev,
# protobuf-1-5
#               golang-protobuf-extensions-dev,
               golang-toml-dev,
               golang-websocket-dev,
# protobuf-1-5
#               golang-google-grpc-dev (>= 1.38~),
               libimage-exiftool-perl,
               golang-github-kylelemons-godebug-dev,
               golang-github-cli-browser-dev
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/ruby-team/gitlab.git
Vcs-Browser: https://salsa.debian.org/ruby-team/gitlab
Homepage: https://about.gitlab.com/
XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab
Rules-Requires-Root: no

Package: gitlab
Section: contrib/net
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 gitlab-common (>= 17.5.5+debian1~),
 ruby (>= 1:3.3~),
 ruby-rubygems (>= 3.6.7~),
# for building openssl 3.0.2, see #1032070
 ruby-dev,
 libssl-dev,
 lsb-base (>= 3.0-6),
 rake (>= 12.3.0~),
 ruby-bundler (>= 2.6~),
 postgresql-client,
 postgresql-contrib (>= 12~),
 dbconfig-pgsql | dbconfig-no-thanks,
 bc,
 redis-server (>= 5:7.0.15~),
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=956211
 nodejs (>= 12~),
# For cleaning up trailing coma in package.json after packageManager is removed
 node-json5,
 nginx | httpd,
 default-mta | postfix | exim4 | mail-transport-agent,
 openssh-client,
 bzip2,
 ucf,
 gitlab-workhorse (>= ${source:Version}),
 ruby-rails (>= 2:6.1.7.2~),
   ruby-websocket-extensions (>= 0.1.5~),
   ruby-zeitwerk (>= 2.6.1~),
 ruby-bootsnap (>= 1.18.3~),
 ruby-ipaddr (>= 1.2.5~),
# for gitlab-secret_detection
   ruby-parallel (>= 1.22~),
 ruby-sprockets (>= 3.7~),
 ruby-pg (>= 1.5.6~),
 ruby-neighbor (>= 0.2.3~),
 ruby-rugged (>= 1.6~),
 ruby-faraday (>= 1.0~),
 ruby-marginalia (>= 1.11.1~),
# Authorization
 ruby-declarative-policy (>= 1.1),
# Authentication libraries
 ruby-bcrypt (>= 3.1.14~),
 ruby-doorkeeper (>= 5.6.6~),
 ruby-doorkeeper-openid-connect (>= 1.8.6~),
 ruby-rexml (>= 3.2.3.1~),
 ruby-omniauth (>= 2.1~),
 ruby-omniauth-azure-activedirectory-v2 (>= 2.0~),
 ruby-omniauth-dingtalk-oauth2 (>= 1.0.1~),
 ruby-omniauth-alicloud (>= 3.0~),
 ruby-omniauth-facebook (>= 4.0~),
 ruby-omniauth-github (>= 2.0.1~),
 ruby-omniauth-gitlab (>= 1.0.2~),
 ruby-omniauth-google-oauth2 (>= 1.1~),
 ruby-omniauth-oauth2-generic (>= 0.2.2~),
 ruby-omniauth-authentiq (>= 0.3.3~),
 ruby-openid-connect (>= 1.3~),
 ruby-omniauth-atlassian-oauth2 (>= 0.2.0~),
 ruby-rack-oauth2 (>= 1.21.3~),
 ruby-jwt (>= 2.1~),
# Spam and anti-bot protection
 ruby-recaptcha (>= 5.12~),
 ruby-akismet (>= 3.0~),
 ruby-invisible-captcha (>= 2.1~),
# Two-factor authentication
 ruby-rqrcode (>= 2.0~),
# GitLab Pages
 ruby-validates-hostname (>= 1.0.13~),
 ruby-zip (>= 2.3.2~),
# GitLab Pages letsencrypt support
 ruby-acme-client (>= 2.10.really.2.0.18~),
# Browser detection
 ruby-browser (>= 5.3.1~),
# OS detection for usage ping
 ohai (>= 18.1~),
# GPG
 ruby-gpgme (>= 2.0.23~),
# LDAP Auth
 ruby-net-ldap (>= 0.17.1~),
# API
 ruby-rack-cors (>= 2.0.1~),
# GraphQL API
 ruby-graphql (>= 2.0.27~),
 ruby-apollo-upload-server (>= 2.1.5~),
# Generate Fake data
 ruby-ffaker (>= 2.23~),
#
 ruby-hashie (>= 5.0~),
# Pagination
 ruby-kaminari (>= 1.2.2~),
# HAML
 ruby-hamlit (>= 2.15~),
# Files attachments
# carrierwave 1.x installed via rubygems.org
# ruby-carrierwave (>= 1.3.2~),
 ruby-mini-magick (>= 4.12~),
# for backups
 ruby-fog-aws (>= 3.18~),
# gitlab need fog-core = 2.1.0
# ruby-fog-core (>= 2.1~),
   ruby-excon (>= 0.72~),
 ruby-fog-google (>= 1.19~),
 ruby-fog-local (>= 0.8~),
 ruby-fog-aliyun (>= 0.4.0~),
 ruby-gitlab-fog-azure-rm (>= 1.9.1~),
   ruby-azure-storage-blob (>= 2.0.0-3~),
   ruby-azure-storage-common (>= 2.0.1-5~),
# for Google storage
 ruby-google-apis-core (>= 0.11.1~),
 ruby-google-apis-compute-v1 (>= 0.57~),
 ruby-google-apis-container-v1beta1 (>= 0.43~),
 ruby-google-apis-container-v1 (>= 0.43~),
 ruby-google-apis-cloudbilling-v1 (>= 0.21~),
 ruby-google-apis-cloudresourcemanager-v1 (>= 0.31~),
 ruby-google-apis-iam-v1 (>= 0.36~),
 ruby-google-apis-serviceusage-v1 (>= 0.28~),
 ruby-google-apis-sqladmin-v1beta4 (>= 0.41~),
 ruby-google-apis-androidpublisher-v3 (>= 0.34~),
# for aws storage
 ruby-unf (>= 0.1.4-2~),
   ruby-unf-ext (>= 0.0.7.4),
# Seed data
 ruby-seed-fu (>= 2.3.7~),
# Search
 ruby-elasticsearch-model (>= 7.2~),
 ruby-elasticsearch (>= 5.0.3~),
 ruby-elasticsearch-rails (>= 7.2~),
 ruby-elasticsearch-api (>= 7.17.11~),
 ruby-aws-sdk-core (>= 3.196.1~),
 ruby-aws-sdk-cloudformation (>= 1.0~),
 ruby-aws-sdk-s3 (>= 1.157~),
 ruby-faraday-typhoeus (>= 1.1~),
 ruby-faraday-middleware-aws-sigv4 (>= 1.0.1~),
 ruby-typhoeus (>= 1.4~),
# Markdown and HTML processing
 ruby-html-pipeline (>= 2.14.3~),
 ruby-task-list (>= 2.3.1~),
 ruby-gitlab-markup (>= 1.9~),
 ruby-github-markup (>= 1.7~),
 ruby-commonmarker (>= 0.23.10~),
 ruby-kramdown (>= 2.3.1~),
 ruby-redcloth (>= 4.3.3~),
# rdoc is built-in with ruby
 ruby-org (>= 0.9.12-2~),
 ruby-creole (>= 0.5.0~),
 ruby-wikicloth (>= 0.8.1~),
 asciidoctor (>= 2.0.18~),
 ruby-asciidoctor-include-ext (>= 0.4~),
 ruby-asciidoctor-plantuml (>= 0.0.16~),
 ruby-asciidoctor-kroki (>= 0.8~),
 ruby-rouge (>= 4.2~),
 ruby-truncato (>= 0.7.12~),
 ruby-nokogiri (>= 1.16~),
 ruby-escape-utils (>= 1.2.1~),
# Diffs
 ruby-diffy (>= 3.4~),
 ruby-diff-match-patch (>= 0.1~),
# Application server
 ruby-rack (>= 2.2.7~),
 ruby-rack-timeout (>= 0.7~),
 puma (>= 6.3~),
 ruby-puma-worker-killer (>= 0.3.1~),
 ruby-sd-notify,
# State machine
 ruby-state-machines-activerecord (>= 0.8~),
   ruby-state-machines-activemodel (>= 0.7.1~),
# Issue tags
 ruby-acts-as-taggable-on (>= 10.0~),
# Background jobs
 ruby-sidekiq (>= 7~),
 ruby-redis-namespace (>= 1.10~),
# HTTP requests
 ruby-httparty (>= 0.16.4~),
# Colored output to console
 ruby-rainbow (>= 3.0~),
# Progress bar
 ruby-progressbar (>= 1.10~),
# Linear-time regex library for untrusted regular expressions
 ruby-re2 (>= 2.6~),
# Misc
 ruby-semver-dialects (>= 3.0~),
 ruby-version-sorter (>= 2.3~),
# Export Ruby Regex to Javascript
 ruby-js-regex (>= 3.8~),
# User agent parsing
 ruby-device-detector,
# Redis
 ruby-redis (>= 4.7~),
 ruby-connection-pool (>= 2.4~),
# Discord integration
 ruby-discordrb-webhooks (>= 3.5~),
# Flowdock integration
 ruby-flowdock (>= 0.7~),
   ruby-posix-spawn (>= 0.3.13~),
# Slack integration
 ruby-slack-messenger (>= 2.3.5~),
# Hangouts Chat integration
 ruby-hangouts-chat (>= 0.0.5),
# FogBugz integration
 ruby-fogbugz (>= 0.3.0~),
# Kubernetes integration
 ruby-kubeclient (>= 4.11~),
   ruby-recursive-open-struct (>= 1.1.1~),
   ruby-http (>= 4.4~),
# AI
 ruby-ruby-openai (>= 3.7~),
 ruby-circuitbox (>= 2.0~),
# Sanitize user input
 ruby-sanitize (>= 6.0.2~),
 ruby-babosa (>= 2.0~),
# Sanitizes SVG input
 ruby-loofah (>= 2.22~),
# Protect against bruteforcing
 ruby-rack-attack (>= 6.7~),
# Ace editor
 ruby-ace-rails-ap (>= 4.1~),
# Detect and convert string character encoding
 ruby-charlock-holmes (>= 0.7.9~),
# Detect mime content type from content
 ruby-ruby-magic (>= 0.6~),
# Faster blank
 ruby-fast-blank,
# Parse time & duration
 ruby-gitlab-chronic (>= 0.10.5~),
 ruby-gitlab-chronic-duration (>= 0.12~),
# We use yarn to downlod nodejs modules and hence gitlab is in contrib
 yarnpkg (>= 1.22.19+~cs24.27.18-2+deb12u1),
 ruby-rack-proxy (>= 0.7.7~),
#
 ruby-cssbundling-rails,
#
 ruby-addressable (>= 2.8~),
 ruby-tanuki-emoji (>= 0.9~),
 ruby-request-store (>= 1.5.1~),
 ruby-virtus (>= 1.0.5-3~),
 ruby-base32 (>= 0.3.0~),
# Sentry integration
 ruby-sentry-raven (>= 3.1~),
 ruby-sentry-ruby (>= 5.17.3~),
 ruby-sentry-rails (>= 5.17.1~),
 ruby-sentry-sidekiq (>= 5.17.3~),
# I18n
 ruby-ruby-parser (>= 3.20~),
 ruby-whitequark-parser (>= 3.0~),
 ruby-rails-i18n (>= 7.0.9~),
 ruby-gettext-i18n-rails (>= 1.12~),
#
 ruby-batch-loader (>= 2.0.1~),
#
 ruby-tty-prompt,
# Perf bar
 ruby-peek (>= 1.1~),
# Snowplow events tracking
 ruby-snowplow-tracker (>= 0.8~),
# Metrics
 ruby-method-source (>= 1.0~),
 ruby-webrick (>= 1.8.1~),
 ruby-prometheus-client-mmap (>= 1.1.1~),
#
 ruby-warning (>= 1.3~),
#
 ruby-email-reply-trimmer (>= 0.1~),
 ruby-html2text,
#
 ruby-prof (>= 1.3~),
 ruby-stackprof (>= 0.2.23~),
 ruby-rbtrace (>= 0.4~),
 ruby-memory-profiler (>= 1.0~),
 ruby-activerecord-explain-analyze (>= 0.1~),
# OAuth
 ruby-oauth2 (>= 2.0~),
# oauth2 2.0 is installed from rubygems.org
   ruby-omniauth-oauth2 (>= 1.7.3~),
# Health check
 ruby-health-check (>= 3.0~),
# System information
 ruby-vmstat (>= 2.3~),
 ruby-sys-filesystem (>= 1.4.3~),
# NTP client
 ruby-net-ntp,
# SSH keys support
 ruby-ssh-data (>= 1.2~),
# Spamcheck GRPC protocol definitions
 ruby-spamcheck (>= 1.10.1~),
#
 ruby-toml-rb (>= 2.2~),
# Feature toggles
 ruby-flipper (>= 0.26.2~),
 ruby-flipper-active-record (>= 0.26.2~),
 ruby-flipper-active-support-cache-store (>= 0.26.2~),
 ruby-unleash (>= 3.2.2~),
 ruby-gitlab-experiment (>= 0.9.1~),
# Structured logging
 ruby-lograge (>= 0.10~),
# DNS Lookup

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
BUILDDIR := _build/src/gitlab.com/gitlab-org/gitlab
VENDORDIR := ${BUILDDIR}/vendor
SYSTEMGOCODE := /usr/share/gocode/src

%:
	dh $@ --buildsystem=ruby --with=ruby --package=gitlab
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build \
	--package=gitlab-workhorse --sourcedirectory=workhorse

override_dh_auto_configure-indep:
	dh_auto_configure -O--package=gitlab -O--buildsystem=ruby -O--with=ruby

override_dh_auto_configure-arch:
	dh_auto_configure -O--package=gitlab-workhorse -O--buildsystem=golang \
	-O--with=golang -O--builddirectory=_build -O--sourcedirectory=workhorse
	# we don't need gitlab's (ruby) vendor directory
	rm -rf ${VENDORDIR}
	# workhorse-vendor is meant for workhorse, but should be renamed
	mv ${BUILDDIR}/workhorse-vendor ${VENDORDIR}
	# merge vendor from gitaly with vendor in build directory using simbolic links
	# if the command fails with errors like cp: not replacing '_build/src/gitlab.com/gitlab-org/gitlab/vendor/...'
	# then remove any conflicting modules from workhorse-vendor tarball
	cp -arsn ${SYSTEMGOCODE}/gitlab.com/gitlab-org/gitaly/v16/vendor/* \
	${VENDORDIR}/
	# import paths in vendor needs version as directory (go.mod is ignored)
	mkdir -p ${VENDORDIR}/github.com/cespare/xxhash/v2
	mkdir -p ${VENDORDIR}/github.com/oklog/ulid/v2
	cp -arsn ${SYSTEMGOCODE}/github.com/cespare/xxhash/* ${VENDORDIR}/github.com/cespare/xxhash/v2
	cp -arsn ${SYSTEMGOCODE}/github.com/oklog/ulid/* ${VENDORDIR}/github.com/oklog/ulid/v2
	# only go files gets copied, but we need files like gitlab-logo.png
	cp -rf workhorse ${BUILDDIR}
	# Remove non-existent symlink
	find ${BUILDDIR} -name test.git -delete

override_dh_auto_build-indep:
	dh_auto_build -O--package=gitlab -O--buildsystem=ruby -O--with=ruby

override_dh_auto_build-arch:
	dh_auto_build -O--package=gitlab-workhorse -O--buildsystem=golang \
	-O--with=golang -O--builddirectory=_build -O--sourcedirectory=workhorse
	# Rename binary to gitlab-workhorse (upstream is passing -o in Makefile)
	if [ -f _build/bin/workhorse ]; then \
	mv _build/bin/workhorse _build/bin/gitlab-workhorse; fi

override_dh_auto_test-indep:
	dh_auto_test -O--package=gitlab -O--buildsystem=ruby -O--with=ruby

override_dh_auto_test-arch:
	PATH="$(CURDIR)/_build/bin:$$PATH" dh_auto_test -O--package=gitlab-workhorse \
	-O--buildsystem=golang -O--with=golang -O--builddirectory=_build \
	-O--sourcedirectory=workhorse

override_dh_auto_install-indep:
	# skip gem2deb copying files to /usr/lib/ruby

override_dh_auto_install-arch:
	dh_auto_install -O--package=gitlab-workhorse -O--buildsystem=golang \
	-O--with=golang -O--builddirectory=_build -O--sourcedirectory=workhorse

override_dh_install-indep:
	sh debian/upstream-file-count-check.sh
	sh debian/upstream-config-file-check.sh
	dh_install -XLICENSE -O--package=gitlab -O--buildsystem=ruby -O--with=ruby
	dh_installexamples -O--package=gitlab -O--buildsystem=ruby -O--with=ruby
	# Make sure we are installing all required files in debian/install
	rm -rf debian/gitlab/usr/share/gitlab/tmp/*
	find debian/gitlab/usr/share/gitlab/ -name .eslintrc.yml -delete
	mv debian/gitlab/usr/share/gitlab/app/assets/javascripts/locale \
	debian/gitlab/usr/share/gitlab/app/assets/javascripts/locale.static
	if [ -f debian/gitlab/var/lib/gitlab/db/structure.sql ]; then \
	  mv debian/gitlab/var/lib/gitlab/db/structure.sql debian/gitlab/var/lib/gitlab/db/structure.sql.template; fi
	sed -i 's/__NEW_VERSION__/${DEB_VERSION}/g' debian/gitlab/usr/lib/gitlab/templates/gitlab-debian.conf.example

override_dh_install-arch:
	dh_install -XLICENSE -O--package=gitlab-workhorse -O--buildsystem=golang \
	-O--with=golang -O--builddirectory=_build -O--sourcedirectory=workhorse

execute_before_dh_installdeb:
	if command -v dh_movetousr >/dev/null; then dh_movetousr; fi

override_dh_installsystemd-indep:
	dh_installsystemd --no-start -p gitlab --name=gitlab-sidekiq -O--package=gitlab
	dh_installsystemd --no-start -p gitlab --name=gitlab-puma -O--package=gitlab
	dh_installsystemd --no-start -p gitlab --name=gitlab-mailroom -O--package=gitlab
	dh_installsystemd --no-start -p gitlab --name=gitlab-workhorse -O--package=gitlab
	dh_installsystemd -O--package=gitlab -O--buildsystem=ruby -O--with=ruby

override_dh_golang-indep:
	# don't fail in arch:all build, is there a better way ?

override_dh_dwz:
	# Do nothing

=== debian/tests/control ===
Tests: spec
Depends: @, 
  sudo,
  gem2deb-test-runner,
# For building native gems
  ruby-rspec,
  ruby-dev,
  gcc,
  libc6-dev,
  ruby-sqlite3,
# For building gitlab-shell
  golang-any,
# Dependencies in test group
  ruby-fuubar (>= 2.2~),
  ruby-rspec-retry (>= 0.6.1~),
  ruby-rspec-profiling,
  ruby-rspec-parameterized,
  ruby-capybara,
  ruby-selenium-webdriver (>= 3.142~),
  ruby-shoulda-matchers (>= 4.0.1~),
  ruby-email-spec (>= 2.2~),
  ruby-json-schema (>= 2.8~),
  ruby-webmock (>= 3.5.1~),
  ruby-rails-controller-testing,
  ruby-test-prof (>= 0.12~),
  ruby-rspec-junit-formatter,
  ruby-bullet,
  ruby-pry-byebug (>= 3.5.1~),
  ruby-pry-rails,
  ruby-awesome-print,
  ruby-database-cleaner (>= 1.7~),
  ruby-rspec-rails (>= 4.0~beta3~),
  ruby-ffaker (>= 2.10~),
  ruby-spring (>= 2.0~),
  ruby-spring-commands-rspec,
  ruby-simplecov,
  ruby-knapsack,
  ruby-simple-po-parser,
  ruby-timecop (>= 0.9.1~),
  ruby-png-quantizator,
  ruby-parallel (>= 1.19~),
  ruby-rblineprof
Restrictions: needs-root, needs-internet

=== debian/watch ===
version=4

# uscan: repacksuffix is not compatible with the multiple upstream tarballs; use oversionmangle.

opts="searchmode=plain" \
 https://gitlab.com/gitlab-org/gitlab-foss/tags?sort=updated_desc -/archive/v?\d[\d.]+/gitlab-foss-v@ANY_VERSION@@ARCHIVE_EXT@

## gitlab api-25.9.8

=== requirements.txt ===
requests>=2.8.1
urllib3>=2.2.2
pydantic[email]>=2.8.2
SQLAlchemy>=2.0.36
alembic>=1.14.1
tenacity>=9.0.0
fastmcp>=2.11.3

## gitlab api-25.12.0

=== requirements.txt ===
requests>=2.8.1
urllib3>=2.2.2
pydantic[email]>=2.8.2
alembic>=1.14.1
tenacity>=9.0.0
fastmcp>=2.12.4
gql>=4.0.0
